package io.ient.test;

import io.ient.test.context.FrameworkTestBase;
import io.ient.test.facets.Login;
import io.ient.test.framework.selenium.WaitTime;
import io.ient.test.framework.utils.DateUtils;
import io.ient.test.framework.utils.RandomDataUtils;
import io.ient.test.framework.utils.annotations.TestCaseID;
import io.ient.test.pages.HomePage;
import io.ient.test.pages.enterprise.ProblemCasePage;
import io.ient.test.pages.enterprise.RoleManagementPage;
import io.ient.test.pages.enterprise.SupplyChainIssueMgmtPage;
import io.ient.test.pages.enterprise.UserManagementPage;
import io.ient.test.pages.project.ProjectSettingsPage;
import org.testng.annotations.Test;
import org.testng.asserts.SoftAssert;

import java.util.List;

public class DelegateTest extends FrameworkTestBase {

    @TestCaseID(ids = {"IENT-1444" , "IENT-1466"})
    @Test
    public void verifyDelegateUser() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnDelegateLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String buyerUserName = testContext.app.getBuyerUser();
        homePage.searchUserByName(buyerUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        String date = DateUtils.getFormattedDateWithTimeZone(0,"DD","IST");
        String month = DateUtils.getFormattedDateWithTimeZone(0,"MM","IST");
        String year = DateUtils.getFormattedDateWithTimeZone(0,"YYYY","IST");
        String startDate = date +"/"+month+"/"+year;
        String endDate = date +"/"+month+"/"+year;
        homePage.clickOnUserLink();
        homePage.delegateUserStartAndEndDate();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        boolean isEnterPriseButtonDisplayed = homePage.isEnterPriseButtonDisplayed();
        softAssert.assertTrue(isEnterPriseButtonDisplayed, "Failed to display enterprise feature");
        boolean isProjectButtonDisplayed = homePage.isProjectButtonDisplayed();
        softAssert.assertTrue(isProjectButtonDisplayed, "Failed to display project feature");
        homePage.clickOnAdminDropDownLink();
        boolean isDelegationLinkDisplayed = homePage.isDelegationLinkDisplayed();
        softAssert.assertTrue(isDelegationLinkDisplayed, "Failed to display delegation feature");
        boolean isEndDelegateLinkDisplayed = homePage.isEndDelegateLinkDisplayed();
        softAssert.assertFalse(isEndDelegateLinkDisplayed, "End delegation should not displayed");
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        boolean isDelegateAccessMessageDisplayed = homePage.isDelegateAccessMessageDisplayed();
        softAssert.assertTrue(isDelegateAccessMessageDisplayed, "Failed to delegate buyer user");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnEndDelegateLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        boolean isSettingsButtonNotDisplayed = homePage.isEnterPriseButtonDisplayed();
        softAssert.assertFalse(isSettingsButtonNotDisplayed, "Settings feature is displayed");
        boolean isProjectButtonNotDisplayed = homePage.isProjectButtonDisplayed();
        softAssert.assertFalse(isProjectButtonNotDisplayed, "Project feature is displayed");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1461"})
    @Test
    public void verifyBuyerUserDelegationToBuyerAdmin() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnDelegateLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        String buyerAdminUserName = testContext.app.getBuyerAdminUser();
        homePage.searchUserByName(buyerAdminUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        homePage.clickOnUserLink();
        homePage.delegateUserStartAndEndDate();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        String problemCaseStatus = "Open Problem Case";
        boolean isProblemCaseDisplayedForBuyerAdmin = problemCasePage.isProblemCaseDisplayed(problemCaseId, problemCaseStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForBuyerAdmin, "Failed to display problem case for buyer admin");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnEndDelegateLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isProblemCaseDisplayedForBuyerAdminAfterDelegationRemoval = problemCasePage.isProblemCaseDisplayed(problemCaseId, problemCaseStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForBuyerAdminAfterDelegationRemoval, "Displayed problem case for buyer admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isProblemCaseEditable = problemCasePage.isProblemCaseEditable();
        softAssert.assertFalse(isProblemCaseEditable, "Able to edit problem case");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1462"})
    @Test
    public void verifyBuyerUser1DelegationToBuyerUser2() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        homePage.clickOnAdminDropDownLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnDelegateLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        String buyerUserName2 = testContext.app.getBuyerUser2();
        homePage.searchUserByName(buyerUserName2);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnUserLink();
        homePage.delegateUserStartAndEndDate();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser2(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        String problemCaseStatus = "Open Problem Case";
        boolean isProblemCaseDisplayedForBuyerAdmin = problemCasePage.isProblemCaseDisplayed(problemCaseId, problemCaseStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForBuyerAdmin, "Failed to display problem case for buyer user2");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnEndDelegateLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser2(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isProblemCaseDisplayedForBuyerUser2AfterDelegationRemoval = problemCasePage.isProblemCaseDisplayed(problemCaseId, problemCaseStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForBuyerUser2AfterDelegationRemoval, "Displayed problem case for buyer user2");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isProblemCaseEditable = problemCasePage.isProblemCaseEditable();
        softAssert.assertFalse(isProblemCaseEditable, "Able to edit problem case");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1463"})
    @Test
    public void verifySupplierUser1DelegationToSupplierAdmin() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String conversationComment = RandomDataUtils.randomAlphabetic(5);
        String problemDescription = RandomDataUtils.randomAlphabetic(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Submitted to Supplier";
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithSubmittedSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithSubmittedSupplierStatus, "Failed to display problem case with Submitted to Supplier status in supplier admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnCaseFormVerticalButton();
        problemCasePage.updateSupplier();
        String supplierAdminUserName = testContext.app.getSupplierAdminUser();
        String supplierUserName = testContext.app.getSupplierUser();
        problemCasePage.searchUser(supplierUserName);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnDelegateLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.searchUserByName(supplierAdminUserName);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnUserLink();
        homePage.delegateUserStartAndEndDate();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isProblemCaseDisplayedForBuyerAdmin = problemCasePage.isProblemCaseDueDateDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForBuyerAdmin, "Failed to display problem case for supplier admin");
        //Need to check editable status
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnEndDelegateLink();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isProblemCaseDisplayedForSupplierAdminAfterDelegationRemoval = problemCasePage.isProblemCaseDueDateDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForSupplierAdminAfterDelegationRemoval, "Displayed problem case for supplier admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isProblemCaseEditable = problemCasePage.isProblemCaseEditable();
        softAssert.assertFalse(isProblemCaseEditable, "Able to edit problem case");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1464"})
    @Test
    public void verifySupplierAdminDelegationToSupplierUser() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String conversationComment = RandomDataUtils.randomAlphabetic(5);
        String problemDescription = RandomDataUtils.randomAlphabetic(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Submitted to Supplier";
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        String supplierUserName = testContext.app.getSupplierUser();
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnDelegateLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.searchUserByName(supplierUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        homePage.clickOnUserLink();
        homePage.delegateUserStartAndEndDate();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isProblemCaseDisplayedForBuyerAdmin = problemCasePage.isProblemCaseDueDateDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForBuyerAdmin, "Failed to display problem case for supplier user");
        //Need to check editable status
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnEndDelegateLink();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isProblemCaseEditable = problemCasePage.isProblemCaseEditable();
        softAssert.assertFalse(isProblemCaseEditable, "Able to edit problem case");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-2373"})
    @Test
    public void verifyDefaultDelegationAccess() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        RoleManagementPage roleManagementPage = new RoleManagementPage(driver);
        UserManagementPage userManagementPage = new UserManagementPage(driver);
        ProjectSettingsPage projectSettingsPage = new ProjectSettingsPage(driver);
        SupplyChainIssueMgmtPage supplyChainIssueMgmtPage = new SupplyChainIssueMgmtPage(driver);
        roleManagementPage.clickOnRoleManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String defaultRole = "DELEGATE_ACCESS";
        roleManagementPage.searchRoleByName(defaultRole);
        driver.sleep(WaitTime.XSMALL_WAIT);
        roleManagementPage.clickOnSearchIcon();
        boolean isDefaultRoleDisplayedInRoles = roleManagementPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDefaultRoleDisplayedInRoles, "Default role is displaying");
        homePage.clickOnEnterprise();
        userManagementPage.clickOnUserManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        roleManagementPage.searchRoleByName(defaultRole);
        driver.sleep(WaitTime.XSMALL_WAIT);
        roleManagementPage.clickOnSearchIcon();
        boolean isDefaultRoleDisplayedInUsers = roleManagementPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDefaultRoleDisplayedInUsers, "Default role is displaying");
        homePage.clickOnProject();
        String appName = "App_" + RandomDataUtils.getRandomAlphanumeric(4);
        String appDescription = "AppDesc_" + RandomDataUtils.getRandomAlphanumeric(4);
        projectSettingsPage.createApp(appName, appDescription);
        supplyChainIssueMgmtPage.clickOnCreateButton();
        driver.sleep(WaitTime.SMALL_WAIT);
        projectSettingsPage.clickOnTagsDropdown();
        List<String> tagsList = projectSettingsPage.getTagsList();
        boolean tagsDropdownList = tagsList.contains(defaultRole);
        softAssert.assertFalse(tagsDropdownList, "Default role is displaying in tags dropdown");
        homePage.clickOnAdminDropDownLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isDelegationLinkDisplayedForBA = homePage.isDelegationLinkDisplayed();
        softAssert.assertTrue(isDelegationLinkDisplayedForBA, "Failed to display delegation feature for BA");
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        driver.sleep(WaitTime.XSMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isDelegationLinkDisplayedForBU = homePage.isDelegationLinkDisplayed();
        softAssert.assertTrue(isDelegationLinkDisplayedForBU, "Failed to display delegation feature for BU");
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnAdminDropDownLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isDelegationLinkDisplayedForSA = homePage.isDelegationLinkDisplayed();
        softAssert.assertTrue(isDelegationLinkDisplayedForSA, "Failed to display delegation feature for SA");
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isDelegationLinkDisplayedForSU = homePage.isDelegationLinkDisplayed();
        softAssert.assertTrue(isDelegationLinkDisplayedForSU, "Failed to display delegation feature for SU");
        homePage.clickOnLogoutLink();
        softAssert.assertAll();
    }

}
